mod Ex07a

incl Mtex

incl Mtexrc

incl Maux

loc rem 
  \para \bf  7. CVIČENIE Z PREDMETU 1-AIN-625 ÚVOD DO MATEMATICKEJ LOGIKY PRE 
  PROGRAMÁTOROV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Dátum:  \end utorok 8.11.2011 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-625-lpp/1112zs/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované primitívne 
  rekurzívnym funkciam (rekurzia s mierou, p.r. indexy). Zadanie sa skladá z 
  týchto súborov: 
  \items 
   \item \para Súbor(y) \it  mtex*.cl  \end obsahuje makrá pre CL-TeX. 
   \item \para Súbor(y) \it  maux*.cl  \end obsahuje definície niektorých 
         funkcií a predikátov. 
   \item \para Súbor \it  mxprf.cl  \end obsahuje aritmetizáciu p.r. 
         funkčných symbolov. 
   \item \para Súbor \it  mxpri.cl  \end obsahuje interpreter p.r. funkčných 
         symbolov. 
   \item \para Súbor \it  mxprt.cl  \end obsahuje aritmetizáciu p.r. termov. 
   \item \para Súbor(y) \it  ex*.cl  \end obsahuje úlohy, ktoré máte 
         riešiť na tomto cvičení. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje syntax systému CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohy v tomto súbore: 1 
   \item \para Počet bodov za prémiove úlohy v tomto súbore:: 0 
  \end
  \para Odovzdať do 14.11.2011 (pondelok) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Recursive Functions. Downloadable 
         lecture notes available through the web page of the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [3]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
   \item \para \it  [4]  \end I. Korec. Úvod do teórie algoritmov. Skriptá 
         MFF UK, 1981. 
  \end

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/2 Tex2_appl_mu_sb
  Prefix(80,0,Id(0,Ent('mu'),0),
         Fenced(Op('[',0),Infix(Arg(0),30,2,Op(',',0),Arg(1)),Op(']',0)))

appldisp/2 Tex_f2_rec_af_f
  Prefix(90,2,Subsup(Id(0,'f',0),75,None,Id(1,'+',0)),
         Fenced(Op('(',0),Infix(Arg(0),30,2,Op(',',0),Arg(1)),Op(')',0)))

appldisp/1 Tex_f1_rec_f91
  Prefix(90,2,Subsup(Id(0,'f',0),75,Num('91',0),None),Arg(0))

appldisp/1 Tex1_appl_mu_sb
  Prefix(80,0,Id(0,Ent('mu'),0),Fenced(Op('[',0),Arg(0),Op(']',0)))

appldisp/3 Tex_f3_rec_af_f
  Prefix(90,2,Subsup(Id(0,'f',0),75,None,Id(1,'+',0)),
         Fenced(Op('(',0),
                Infix(Arg(0),30,2,Op(',',0),Infix(Arg(1),30,2,Op(',',0),Arg(2))),
                Op(')',0)))

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Section. Recursion with Measure.  \end 

rem 
  \para \bf  Exercise.  \end \header* fun/2 Gcd 'Tex_f2_n_gcd' \end Consider the 
  following recursive definition of the greatest common divisor function: 

fun/2 Gcd 'Tex_f2_n_gcd'
  Gcd(x,y) = Max(x,y) <- x = 0
  Gcd(x,y) = Max(x,y) <- x != 0 & y = 0
  Gcd(x,y) = Gcd(x,y-x) <- x != 0 & y != 0 & x < y
  Gcd(x,y) = x <- x != 0 & y != 0 & x = y
  Gcd(x,y) = Gcd(x-y,y) <- x != 0 & y != 0 & x > y

rem 
  \para This is a recursion with a suitable measure 
  \ft Tex2_appl_mu_sb(x,y) \end such that 
  \eq* 
    x != 0 & y != 0 & x < y -> Tex2_appl_mu_sb(x,y-x) < Tex2_appl_mu_sb(x,y)
  \end
  \eq* 
    x != 0 & y != 0 & x > y -> Tex2_appl_mu_sb(x-y,y) < Tex2_appl_mu_sb(x,y)
  \end
  \para \header* fun/3 Af_gcd 'Tex_f3_rec_af_f' \end Derive the function as 
  primitive recursive with the help of its approximation function 
  \ft Af_gcd(z,x,y) \end such that 
  \eq* 
    z > Tex2_appl_mu_sb(x,y) -> Af_gcd(z,x,y) = Gcd(x,y)
  \end

fun/3 Af_gcd 'Tex_f3_rec_af_f'
  Af_gcd(z,x,y) = Foo

fun/2 Gcd_is_primrec 'Tex_f2_n_gcd'
  Gcd_is_primrec(x,y) = Foo

rem 
  \para \bf  Exercise. \it  (1 point)  \end  \end Consider the recursive 
  definition of McCarthy 91 function: 

fun F91 'Tex_f1_rec_f91'
  F91(x) = F91 F91(x+11) <- x < 101
  F91(x) = x-10 <- x >= 101

rem 
  \para This is a recursion with a suitable measure \ft Tex1_appl_mu_sb(x) \end 
  such that 
  \eq* 
    x < 101 -> Tex1_appl_mu_sb(x+11) < Tex1_appl_mu_sb(x)
  \end
  \eq* 
    x < 101 -> Tex1_appl_mu_sb F91(x+11) < Tex1_appl_mu_sb(x)
  \end
  \para \header* fun/2 Af_f91 'Tex_f2_rec_af_f' \end Derive the function as 
  primitive recursive with the help of its approximation function 
  \ft Af_f91(z,x) \end such that 
  \eq* 
    z > Tex1_appl_mu_sb(x) -> Af_f91(z,x) = F91(x)
  \end

fun/2 Af_f91 'Tex_f2_rec_af_f'
  Af_f91(z,x) = Foo

fun F91_is_primrec 'Tex_f1_rec_f91'
  F91_is_primrec(x) = Foo

rem 
  \para \bf  Theorem.  \end Primitive recursive functions are closed under 
  recursion with measure. 

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun Test_fun 
  Test_fun(x) = Foo

loc fun/2 Itfa 
  Itfa(0,a) = a
  Itfa(n+1,a) = Itfa(n,(n,Test_fun(n)),a)

loc fun Itf 
  Itf(n) = Itfa(n,0)

loc pred Test_pred 
  Test_pred(x) <-> Poo

loc fun/2 Itpa 
  Itpa(0,a) = a
  Itpa(n+1,a) = Itpa(n,n,a) <- Test_pred(n)
  Itpa(n+1,a) = Itpa(n,a) <- ~Test_pred(n)

loc fun Itp 
  Itp(n) = Itpa(n,0)

