mod Mxpri

incl Mtex

incl Mtexrc

incl Mtexxpr

incl Mxprf

incl Maux

rem 
  \para \bf  Interpreter of primitive recursive function symbols.  \end 

fun/2 Interpreter 'Tex_f2_xpr_interpreter'
  Interpreter(Zx,x) = 0
  Interpreter(Sx,x) = x+1
  Interpreter(Ix(n,i),x) = Proj(n,x,i)
  Interpreter(Px(g,gs),x) = Interpreter(g,x),Interpreter(gs,x)
  Interpreter(Cx(n,m,h,gs),x) = Interpreter(h,Interpreter(gs,x))
  Interpreter(Rx(n,g,h),0,y) = Interpreter(g,y)
  Interpreter(Rx(n,g,h),x+1,y) = Interpreter(h,x,Interpreter(Rx(n,g,h),x,y),y)

